/**
 * Performance Observer Polyfill
 * Version: 2.0.0
 * Generated: 2021-02-23
 * https://github.com/fastly/performance-observer-polyfill
 *
 * Copyright (c) 2021, Fastly, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e="undefined"!=typeof globalThis?globalThis:e||self).PerformanceObserver=t()}(this,(function(){"use strict";var e=function(){function e(e){this._entries=e}return e.prototype.getEntries=function(){return this._entries},e.prototype.getEntriesByType=function(e){return this._entries.filter((function(t){return t.entryType===e}))},e.prototype.getEntriesByName=function(e,t){return this._entries.filter((function(t){return t.name===e})).filter((function(e){return!t||e.entryType===t}))},e}(),t=function(){function t(e){var t=void 0===e?{}:e,r=t.registeredObservers,n=void 0===r?new Set:r,s=t.processedEntries,o=void 0===s?new Set:s,i=t.interval,f=void 0===i?100:i,c=t.context,u=void 0===c?self:c;this.registeredObservers=n,this.processedEntries=o,this.interval=f,this.context=u,this.intervalId=null}return t.prototype.getNewEntries=function(){var e=this;return this.context.performance.getEntries().filter((function(t){return!e.processedEntries.has(t)}))},t.prototype.getObserversForType=function(e,t){return Array.from(e).filter((function(e){return e.entryTypes.some((function(e){return e===t}))}))},t.prototype.processBuffer=function(t){var r=Array.from(t.buffer),n=new e(r);t.buffer.clear(),r.length&&t.callback&&t.callback.call(void 0,n,t)},t.prototype.processEntries=function(){var e=this;this.getNewEntries().forEach((function(t){var r=t.entryType;e.getObserversForType(e.registeredObservers,r).forEach((function(e){e.buffer.add(t)})),e.processedEntries.add(t)}));var t=function(){return e.registeredObservers.forEach(e.processBuffer)};"requestAnimationFrame"in this.context?this.context.requestAnimationFrame(t):this.context.setTimeout(t,0)},t.prototype.add=function(e){this.registeredObservers.add(e),1===this.registeredObservers.size&&this.observe()},t.prototype.remove=function(e){this.registeredObservers.delete(e),this.registeredObservers.size||this.disconnect()},t.prototype.observe=function(){this.intervalId=this.context.setInterval(this.processEntries.bind(this),this.interval)},t.prototype.disconnect=function(){this.intervalId=this.context.clearInterval(this.intervalId)},t}(),r=["mark","measure","navigation","resource"],n="Failed to execute 'observe' on 'PerformanceObserver': either an 'entryTypes' or 'type' member must be present.",s="Failed to execute 'observe' on 'PerformanceObserver': either an 'entryTypes' or 'type' member must be present, not both.",o="Aborting 'observe' on 'PerformanceObserver': no valid entry types present in either 'entryTypes' or 'type' member.",i="Invalid or unsupported entry types provided to 'observe' on 'PerformanceObserver'.",f=function(e){return r.some((function(t){return e===t}))},c=new t,u=function(){function e(e,t){void 0===t&&(t=c),this.entryTypes=[],this.callback=e,this.buffer=new Set,this.taskQueue=t}return e.prototype.observe=function(e){if(!e)throw new Error(n);if(e.entryTypes&&e.type)throw new Error(s);var t;if(e.entryTypes)t=e.entryTypes;else{if(!e.type)throw new Error(n);t=[e.type]}var r=t.filter(f);r.length>0&&r.length!==t.length&&console.warn(i),r.length?(this.entryTypes=r,this.taskQueue.add(this)):console.warn(o)},e.prototype.disconnect=function(){this.taskQueue.remove(this)},e.prototype.takeRecords=function(){return Array.from(this.buffer)},e.supportedEntryTypes=r,e}();return"PerformanceObserver"in self&&"function"==typeof PerformanceObserver?PerformanceObserver:u}));
